unit mAmpel;  {hier muss der Dateiname stehen !!}

interface     {Begin des Teils, der angibt, was von auen sichtbar
               ist und wie darauf zugegriffen werden kann }

uses mSuM;    {units, auf die zugegriffen wird}

    type TAmpel = class              {Begin der Deklaration einer Objektklasse}

         private                     {Auf den folgenden Teil kann von auen
                                      nicht zugegriffen werden}
           zAktuelleFarbe : integer; {erst die inneren Zustnde, dann die      }
           hatStift : BuntStift;     {Prozeduren und Funktionen                }
           zx,zy : zahl;
           procedure zeichneDich;

         public                      {auf den nun folgendten Teil kann von     }
                                     {auen zugegriffen werden                 }
           constructor init(px,py : zahl);
           destructor gibfrei;       {Hier stehen die Prozedurkpfe            }
           procedure schalteUm;      {                    mit Parameterliste   }
           function farbe:integer;   {Die Reihenfolge ist beliebig             }
           function links : zahl;    {Der Klassenname wird nicht hinzugesetzt  }
           function rechts : zahl;
           function oben : zahl;
           function unten : zahl;

     end;                            {Ende des Interface-Teils}

implementation

 constructor TAmpel.init(px,py : zahl); {Hier muss vor dem Namen des Dienstes }
     begin                              {der Name der Klasse - getrennt durch }
       zAktuelleFarbe := rot;           {einen Punkt - stehen.                }
       hatStift := BuntStift.init;
       zx := px;
       zy := py;
       self.zeichneDich                 {Dies ist ein Auftrag an sich selbst  }
    end;

 destructor TAmpel.gibfrei;
    begin
      hatStift.gibfrei;
    end;

 procedure TAmpel.zeichneDich;
    begin
       with hatStift do begin
          bewegeBis(zx,zy);
          setzeFarbe(schwarz);
          setzeLinienbreite(1);
          runter;
          zeichneRechteck(16,32);

          hoch; // unteres Licht
          bewegeBis(zx+8,zy+24);
          runter;
          if zAktuelleFarbe = gruen then begin
              setzeFarbe(gruen);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end ;
          zeichneKreis(5);

          hoch; // oberes Licht
          bewegeBis(zx+8,zy+8);
          if zAktuelleFarbe = rot then begin
              setzeFarbe(rot);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end;
          zeichneKreis(5);

       end // with
  end;

procedure TAmpel.schalteUm;
  begin
     if zAktuelleFarbe = rot then
        zAktuelleFarbe := gruen
     else
        zAktuelleFarbe := rot;
     self.zeichneDich
 end;

function TAmpel.farbe;
   begin
      result := zAktuelleFarbe
   end;

function TAmpel.links;
   begin
      result := zx
   end;

function TAmpel.rechts;
   begin
      result := zx+16
   end;

function TAmpel.oben;
   begin
      result := zy
   end;

function TAmpel.unten;
   begin
      result := zy+32
   end;



end.
