program Tverwaltung;

uses
  mSuM,
  mTAmpel in 'mTAmpel.pas',
  mTAuto in 'mTAuto.pas';

var
  meinStift: Stift;
  derBildschirm : Bildschirm; 
  dieTastatur : Tastatur; 
  dieMaus : Maus;
  Auto1,Auto2:TAuto;
  Ampel1,Ampel2 : TAmpel;

begin

{----- Objekte erzeugen und initialisieren ----- }
  derBildschirm := Bildschirm.init;
  meinStift := Stift.init;
  dieTastatur := Tastatur.init;
  dieMaus := Maus.init;
  Auto1 := TAuto.init(0,325,0);
  Auto2 := TAuto.init(derBildschirm.breite-30,275,180);
  Ampel1 := TAmpel.init(180,360);
  Ampel2 := TAmpel.init(derBildschirm.breite-200,210);


  {----- Methodenaufrufe usw. -----}

  //Benutzerinformation
  meinStift.bewegeBis(derBildschirm.breite-200,350);
  meinStift.schreibeText('Ende: Leertaste drcken');
  meinStift.bewegeBis(180,400);
  meinStift.schreibeText('Ampel umschalten : a');

  // obere Strassenlinie
  meinStift.bewegeBis(0,250);
  meinStift.runter ;
  meinStift.bewegeBis(derBildschirm.breite,250);
  meinStift.hoch;

  // untere Strassenlinie  (mit Einbuchtung)
  meinStift.bewegeBis(0,350);
  meinStift.runter ;
  meinStift.bewegeBis(200,350);
  meinStift.bewegeBis(300,300);
  meinStift.bewegeBis(derBildschirm.breite-300,300);
  meinStift.bewegeBis(derBildschirm.breite-200,350);
  meinStift.bewegeBis(derBildschirm.breite,350);
  meinStift.hoch;

  ampel1.schalteUm; // damit Ampel1 und Ampel2 gegenlufig sind

repeat

    // Auto 1 ggf bewegen und drehen
    //Auto1.warte;
    if (Ampel1.farbe = rot) and
       (Auto1.hposition + 40 > Ampel1.links) and
       (Auto1.hposition + 30 < Ampel1.links)
    then // auto darf nicht fahren
       begin
          Auto1.warte;
       end  // auto darf nicht fahren
    else //Auto darf fahren
      begin
         Auto1.bewegeDich;

         //drehe dich in netsprechenden Bereichen nach links
         if ((Auto1.hPosition >= 165)  and
            (Auto1.hPosition <= 220) )
            or
            ((Auto1.hPosition > derBildschirm.breite - 220)  and
            (Auto1.hPosition <= derBildschirm.breite - 166) )
         then
            Auto1.dreheUm(1); //links

         //drehe dich in netsprechenden Bereichen nach rechts
         if ( (Auto1.hPosition >= 255)  and
              (Auto1.hPosition <= 312)  )
            or
            ( (Auto1.hPosition > derBildschirm.breite - 318)  and
              (Auto1.hPosition <= derBildschirm.breite - 265)   )
         then
            Auto1.dreheUm(-1); //rechts

         //ggf wieder an den Anfang
         if Auto1.hPosition > derBildschirm.breite + 30
         then
            begin
               Auto1.setzeAuf(0,325);
               Auto1.drehebis(0)
            end // von wieder an den Anfang
      end; // von Auto1 ggf fahren und drehen

      // Auto2 ggf bewegen
      if (Ampel2.farbe = rot) and
         (Auto2.hPosition - 40 < Ampel2.rechts) and
         (Auto2.hPosition - 30 > Ampel2.rechts)
      then
         Auto2.warte
      else
         begin
            Auto2.bewegeDich;
            // Auto2 ggf an den Anfang
            if Auto2.hPosition < -30 then
               Auto2.setzeAuf (derBildschirm.breite+30,275);
         end; // von Auto2 bewegt sich

      // Ampel ggf umschalten
      if dieTastatur.wurdegedrueckt and (dietastatur.zeichen='a') then
         begin
            dieTastatur.weiter;
            Ampel1.schalteUm ;
            Ampel2.schalteUm
         end;

until dieTastatur.wurdegedrueckt;


{----- Objekte auflsen -----}
  meinStift.gibFrei;
  dieMaus.gibFrei;
  dieTastatur.gibFrei;
  derBildschirm.gibFrei;
  Auto1.GibFrei;

end.
