program auto2;

uses
  mSuM, sysutils,
  mampel,
  mauto;

var
  derBildschirm : Bildschirm; 
  dieTastatur : Tastatur;
  dieMaus : Maus;
  derStift : Stift;
  dasAuto1 : Auto;
  dasAuto2 : Auto;
  dieAmpel1 : Ampel;
  dieAmpel2 : Ampel;
  x1, y1, x2, y2, x3, y3, x4, y4 : integer;
  Schleifenabbruch: boolean;

begin

{----- Objekte erzeugen und initialisieren ----- }
  derBildschirm := Bildschirm.init;
  dieTastatur := Tastatur.init;
  dieMaus := Maus.init;
  derStift := Stift.init;
  dasAuto1 := auto.init (0, derBildschirm.hoehe div 2 + 20, 0);
  dasAuto2 := auto.init (derBildschirm.breite div 2 + 20, derBildschirm.hoehe - 60, 90);
  dieampel1 := ampel.init (derBildschirm.breite div 2 - 56, derBildschirm.hoehe div 2 + 40);
  dieampel2 := ampel.init (derBildschirm.breite div 2 + 40, derBildschirm.hoehe div 2 + 40);
  dieampel1.schalteUm;
{----- Methodenaufrufe usw. -----}
{Fahrbahn}
{Ermittlung der Hlfte und Addieren bzw. Subtrahieren einer Fahrspur (40)}


  x1 := (derBildschirm.breite div 2) - 40;
  y1 := (derBildschirm.hoehe div 2) - 40;
  x2 := (derBildschirm.breite div 2) - 40;
  y2 := (derBildschirm.hoehe div 2) + 40;
  x3 := (derBildschirm.breite div 2) + 40;
  y3 := (derBildschirm.hoehe div 2) - 40;
  x4 := (derBildschirm.breite div 2) + 40;
  y4 := (derBildschirm.hoehe div 2) + 40;

  {Zeichnen der Kreuzung}

  derStift.bewegeBis (0,0);
  derStift.runter;
  derStift.zeichneRechteck (x1, y1);
  derStift.hoch;

  derStift.bewegeBis (0,y2);
  derStift.runter;
  derStift.zeichneRechteck (x2, derBildschirm.hoehe - y2);
  derStift.hoch;

  derStift.bewegeBis (x3,0);
  derStift.runter;
  derStift.zeichneRechteck (derBildschirm.breite - x3, y3);
  derStift.hoch;

  derStift.bewegeBis (x4, y4);
  derStift.runter;
  derStift.zeichneRechteck (derBildschirm.breite -x4, derBildschirm.hoehe -y4);
  derStift.hoch;



  {Wird erst beendet, wenn berhaupt der Buchstabe a (Abbruch) gedrckt wurde.}
  Schleifenabbruch := false;
  repeat
        {Tastaturreaktion - Ampelumschaltung}
        if dieTastatur.wurdeGedrueckt then
        begin
        {Unterscheidet die Flle a (Abbruch), u (Umschalten) und () Sonstiges}

              case dieTastatur.zeichen of 'a': ;
                                          'u': begin
                                                   {Ampelumschaltung}
                                                   dieAmpel1.schalteUm;
                                                   dieAmpel2.schalteUm;
                                                   DieTastatur.weiter;
                                               end ;
                                           else dieTastatur.weiter
              end;

        end;

  {Autofahren}

              case dieAmpel1.farbe of gruen: dasAuto1.bewegeDich;
                                       rot : begin
                                             (*derStift.BewegeBis (500,500);
                                             derStift.runter;
                                             derStift.schreibeText (IntToStr(round(dasAuto1.hposition)
                                             )); *)
                                             if (dasAuto1.hposition +30 > dieAmpel1.links)
                                                then dasAuto1.bewegeDich
                                                else // auto links von Ampel
                                                     if (dasAuto1.hposition +30 > (dieAmpel1.links-10))
                                                        then dasAuto1.warte
                                                        else dasAuto1.bewegeDich

                                             { if dasAuto1.hposition +25 < dieAmpel1.links
                                             then while
                                             dasAuto1.hposition +25 < dieAmpel1.links
                                             do dasAuto1.bewegeDich;    }
                                             end;


              end;
              if dasAuto1.hPosition > derBildschirm.breite then
                 dasAuto1.setzeAuf(0,dasAuto1.vPosition);

                case dieAmpel2.farbe of gruen: dasAuto2.bewegeDich;
                                       rot : begin
                                             (*derStift.BewegeBis (500,500);
                                             derStift.runter;
                                             derStift.schreibeText (IntToStr(round(dasAuto1.hposition)
                                             )); *)
                                             if (dasAuto2.vposition -30 < dieAmpel2.oben)
                                                then dasAuto2.bewegeDich
                                                else // auto links von Ampel
                                                     if (dasAuto2.vposition -30 < (dieAmpel2.oben+10))
                                                        then dasAuto2.warte
                                                        else dasAuto2.bewegeDich

                                             { if dasAuto1.hposition +25 < dieAmpel1.links
                                             then while
                                             dasAuto1.hposition +25 < dieAmpel1.links
                                             do dasAuto1.bewegeDich;    }
                                             end;


              end;
              if dasAuto2.vPosition < 0 then
                 dasAuto2.setzeAuf(dasAuto2.hposition, derBildschirm.hoehe)


  until dieTastatur.wurdegedrueckt and (dieTastatur.zeichen='a'); //Schleifenabbruch;



{----- Objekte auflsen -----}
  dieMaus.gibFrei;
  dieTastatur.gibFrei;
  derBildschirm.gibFrei;
  derStift.gibFrei;

end.
