unit mAuto;

interface



uses mSuM,mUhr;

    const laenge = 60.0;
          breite = 30.0;

    type TAuto = class
         private
           meinStift : Stift;
           x,y,zWinkel : zahl;
           meineUhr : Uhr;
           procedure zeichneDich;

         public
           constructor init(px,py : zahl; pWinkel:Zahl);
           destructor GibFrei;
           procedure bewegeDich;
           procedure setzeAuf(pXpos,pYPos:zahl);
           procedure dreheUm (pWinkel:zahl);
           procedure dreheBis (pWinkel:zahl);
           procedure warte;
           function hPosition : zahl;
           function vPosition : zahl;
           function winkel : zahl;


           //destructor gibfrei;
     end;

implementation

 constructor TAuto.init(px,py : zahl; pWinkel:Zahl);
    begin
       meinStift := Stift.init;
       meineUhr := Uhr.init;
       x := px;
       y := py;
       zwinkel := pWinkel;
       zeichneDich;
    end;

 destructor TAuto.gibfrei;
    begin
      meinStift.gibfrei;
      meineUhr.gibfrei;
    end;  

procedure TAuto.zeichneDich;
  begin
    with meinStift do
      begin
        hoch;
        bewegeBis(x,y);
        wechsle;
        dreheBis(zWinkel);
        bewegeUm(laenge*0.1);
        dreheBis (zWinkel+90);
        bewegeUm(breite *0.5);
        runter;
        bewegeUm(-breite);
        hoch;
        bewegeUm(breite*0.5);
        //runter;
        dreheBis(zWinkel+180);
        BewegeUm(laenge*0.5);
        BewegeUm(laenge*0.1);
        dreheUm(-90);
        BewegeUm(breite*0.5);
        dreheUm(-90);

        runter;
        dreheBis(zwinkel);
        BewegeUm(laenge*0.8);
        DreheUm(-90);
        BewegeUm(breite*0.2);
        DreheUm(90);
        bewegeUm(laenge*0.2);
        DreheUm(-90);
        bewegeUm(breite*0.6);
        dreheUm(-90);
        bewegeUm(laenge*0.2);
        dreheUm(90);
        bewegeUm(breite*0.2);
        dreheUm(-90);
        bewegeUm(laenge*0.8);
        dreheUm(-90);
        bewegeUm(breite);
        hoch;
        bewegeUm(-breite*0.5);
        dreheBis(zwinkel);
        bewegeUm(laenge*0.5);
        normal
      end;
  end;

procedure TAuto.bewegeDich;
  begin
    zeichneDich;
    x := x + 2.0 * cos(zwinkel*pi/180);
    y := y - 2.0 * sin(zwinkel*pi/180);
    zeichneDich;
    meineUhr.warte(1)
  end;

procedure TAuto.DreheBis(pWinkel : zahl);
  begin
    zeichneDich;
    zwinkel := pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

procedure TAuto.DreheUm(pWinkel : zahl);
  begin
    zeichneDich;
    zwinkel := zwinkel + pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;


procedure TAuto.warte;
   begin
      meineUhr.warte(1)
   end;
        
procedure TAuto.setzeAuf(pxpos,pYPos:zahl);
   begin
      zeichneDich;
      x := pXpos ;
      y := pYpos ;
      zeichneDich
   end;

function TAuto.hPosition:zahl;
   begin
    result := x;
   end;

function TAuto.vPosition:zahl;
   begin
    result := y;
   end;

function TAuto.winkel:zahl;
   begin
    result := zWinkel;
   end;


end.
