program verwaltung;

uses
  mSuM,
  mAmpel in 'mAmpel.pas';

var
  meinStift: Stift;
  derBildschirm : Bildschirm; 
  dieTastatur : Tastatur; 
  dieMaus : Maus;
  Auto1,Auto2:TAuto;
  Ampel1,Ampel2 : TAmpel;

begin

{----- Objekte erzeugen und initialisieren ----- }
  derBildschirm := Bildschirm.init;
  meinStift := Stift.init;
  dieTastatur := Tastatur.init;
  dieMaus := Maus.init;
  Auto1 := TAuto.init(0,325,0);
  Auto2 := TAuto.init(425,0,270);
  Ampel1 := TAmpel.init(370,360);
  Ampel2 := TAmpel.init(370,210);


  {----- Methodenaufrufe usw. -----}

  //Benutzerinformation
  meinStift.bewegeBis(200,400);
  meinStift.schreibeText('Ampel umschalten : a');
  meinStift.bewegeBis(200,420);
  meinStift.schreibeText('Ende: Leertaste drcken');

  // Kreuzung
  with meinstift do begin
    bewegeBis(0,250);
    runter ;
    bewegeBis(400,250);
    bewegeBis(400,0);
    hoch;

    bewegeBis(0,350);
    runter ;
    bewegeBis(400,350);
    bewegeBis(400,derBildschirm.hoehe);
    hoch;

    bewegeBis(500,0);
    runter ;
    bewegeBis(500,250);
    bewegeBis(derBildschirm.breite,250);
    hoch;

    bewegeBis(500,derBildschirm.hoehe);
    runter ;
    bewegeBis(500,350);
    bewegeBis(derBildschirm.breite,350);
    hoch;
  end; //Kreuzungsende


  ampel1.schalteUm; // damit Ampel1 und Ampel2 gegenlufig sind

repeat

    // Auto 1 ggf bewegen
    if (Ampel1.farbe = rot) and
       (Auto1.hposition + 30 > Ampel1.links) and
       (Auto1.hposition + 25 < Ampel1.links)
    then // auto darf nicht fahren
       begin
          Auto1.warte;
       end  // auto darf nicht fahren
    else //Auto darf fahren
      begin
         Auto1.bewegeDich;
         //ggf wieder an den Anfang
         if Auto1.hPosition > derBildschirm.breite + 30
         then
            begin
               Auto1.setzeAuf(-30,325);
               Auto1.drehebis(0)
            end // von wieder an den Anfang
      end; // von Auto1 ggf fahren und drehen

      // Auto2 ggf bewegen
      if (Ampel2.farbe = rot) and
         (Auto2.vPosition + 30 > Ampel2.unten) and
         (Auto2.vPosition + 25 < Ampel2.unten)
      then
         Auto2.warte
      else
         begin
            Auto2.bewegeDich;
            // Auto2 ggf an den Anfang
            if Auto2.vPosition > derBildschirm.hoehe + 40 then
               Auto2.setzeAuf (425,-30);
         end; // von Auto2 bewegt sich

      // Ampel ggf umschalten
      if dieTastatur.wurdegedrueckt and (dietastatur.zeichen='a') then
         begin
            dieTastatur.weiter;
            Ampel1.schalteUm ;
            Ampel2.schalteUm
         end;

until dieTastatur.wurdegedrueckt;


{----- Objekte auflsen -----}
  meinStift.gibFrei;
  dieMaus.gibFrei;
  dieTastatur.gibFrei;
  derBildschirm.gibFrei;
  Auto1.GibFrei;

end.
