unit mAmpel;



interface

uses mSuM,extctrls;

    type ampel = class
         private
           aktuellefarbe : integer;
           meinStift : BuntStift;
           x,y : zahl;
           dieTastatur : Tastatur;
           procedure zeichneDich;
         public
           constructor init(px,py : zahl);
           destructor gibfrei;
           procedure schalteUm;

           function farbe:integer;
           function links : zahl;
           function rechts : zahl;
           function oben : zahl;
           function unten : zahl;

     end;

implementation

 constructor ampel.init(px,py : zahl);
    begin
       aktuelleFarbe := rot;
       meinStift := BuntStift.init;
       dieTastatur := Tastatur.init;
       x := px;
       y := py;
       zeichneDich
    end;

 destructor ampel.gibfrei;
    begin
      meinStift.gibfrei;
      //meineUhr.gibfrei;
      dieTastatur.gibFrei;
    end;  

 procedure ampel.zeichneDich;
    begin
       with meinStift do begin
          bewegeBis(x,y);
          setzeFarbe(schwarz);
          setzeLinienbreite(1);
          runter;
          zeichneRechteck(16,32);

          hoch; // unteres Licht
          bewegeBis(x+8,y+24);
          runter;
          if aktuellefarbe = gruen then begin
              setzeFarbe(gruen);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end ;
          zeichneKreis(5);

          hoch; // oberes Licht
          bewegeBis(x+8,y+8);
          if aktuellefarbe = rot then begin
              setzeFarbe(rot);
              setzeLinienbreite(3)
          end
          else begin
              setzeFarbe(weiss);
              setzeLinienbreite(3);
              zeichneKreis(5);
              setzeFarbe(schwarz);
              setzeLinienbreite(1);
          end;
          zeichneKreis(5);

       end // with
  end;

procedure ampel.schalteUm;
  begin
     if aktuellefarbe = rot then
        aktuellefarbe := gruen
     else
        aktuellefarbe := rot;
     zeichneDich
 end;

function ampel.farbe;
   begin
      result := aktuellefarbe
   end;

function ampel.links;
   begin
      result := x
   end;

function ampel.rechts;
   begin
      result := x+16
   end;

function ampel.oben;
   begin
      result := y
   end;

function ampel.unten;
   begin
      result := y+32
   end;



end.
