program verwaltung;

uses
  mSuM,
  mAuto ,
  mAmpel ;

var
  meinStift: Stift;
  derBildschirm : Bildschirm; 
  dieTastatur : Tastatur; 
  dieMaus : Maus;
  Auto1,Auto2,Auto3,Auto4:Auto;
  Ampel1,Ampel2,Ampel3,Ampel4 : Ampel;

begin

{----- Objekte erzeugen und initialisieren ----- }
  derBildschirm := Bildschirm.init;
  meinStift := Stift.init;
  dieTastatur := Tastatur.init;
  dieMaus := Maus.init;
  Auto1 := Auto.init(0,325,0);
  Auto2 := Auto.init(425,0,270);
  Auto3 := Auto.init(derBildschirm.breite,275,180);
  Auto4 := Auto.init(475,derBildschirm.hoehe,90);
  Ampel1 := Ampel.init(370,360);
  Ampel2 := Ampel.init(370,210);
  Ampel3 := Ampel.init(510,210);
  Ampel4 := Ampel.init(510,360);


  {----- Methodenaufrufe usw. -----}

  //Benutzerinformation
  meinStift.bewegeBis(200,400);
  meinStift.schreibeText('Ampel umschalten : a');
  meinStift.bewegeBis(200,420);
  meinStift.schreibeText('Ende: Leertaste drcken');

  // Kreuzung
  with meinstift do begin
    bewegeBis(0,250);
    runter ;
    bewegeBis(400,250);
    bewegeBis(400,0);
    hoch;

    bewegeBis(0,350);
    runter ;
    bewegeBis(400,350);
    bewegeBis(400,derBildschirm.hoehe);
    hoch;

    bewegeBis(500,0);
    runter ;
    bewegeBis(500,250);
    bewegeBis(derBildschirm.breite,250);
    hoch;

    bewegeBis(500,derBildschirm.hoehe);
    runter ;
    bewegeBis(500,350);
    bewegeBis(derBildschirm.breite,350);
    hoch;
  end; //Kreuzungsende


  ampel1.schalteUm; // damit Ampel1 und Ampel2 gegenlufig sind
  ampel3.schalteUm; // damit Ampel1 und Ampel2 gegenlufig sind


repeat

    // Auto 1 ggf bewegen
    if (Ampel1.farbe = rot) and
       (Auto1.hposition + 30 > Ampel1.links) and
       (Auto1.hposition + 25 < Ampel1.links)
    then // auto darf nicht fahren
       begin
          Auto1.warte;
       end  // auto darf nicht fahren
    else //Auto darf fahren
      begin
         Auto1.bewegeDich;
         //ggf wieder an den Anfang
         if Auto1.hPosition > derBildschirm.breite + 30
         then
            begin
               Auto1.setzeAuf(-30,325);
            end // von wieder an den Anfang
      end; // von Auto1 ggf fahren und drehen

    // Auto 3 ggf bewegen
    if (Ampel3.farbe = rot) and
       (Auto3.hposition - 30 < Ampel3.rechts) and
       (Auto3.hposition - 25 > Ampel3.rechts)
    then // auto darf nicht fahren
       begin
          Auto3.warte;
       end  // auto darf nicht fahren
    else //Auto darf fahren
      begin
         Auto3.bewegeDich;
         //ggf wieder an den Anfang
         if Auto3.hPosition < - 30
         then
            begin
               Auto3.setzeAuf(derBildschirm.breite+30,275);
            end // von wieder an den Anfang
      end; // von Auto3 ggf fahren und drehen

      // Auto2 ggf bewegen
      if (Ampel2.farbe = rot) and
         (Auto2.vPosition + 30 > Ampel2.unten) and
         (Auto2.vPosition + 25 < Ampel2.unten)
      then
         Auto2.warte
      else
         begin
            Auto2.bewegeDich;
            // Auto2 ggf an den Anfang
            if Auto2.vPosition > derBildschirm.hoehe + 40 then
               Auto2.setzeAuf (425,-30);
         end; // von Auto2 bewegt sich

      // Auto4 ggf bewegen
      if (Ampel4.farbe = rot) and
         (Auto4.vPosition - 30 < Ampel4.oben) and
         (Auto4.vPosition - 25 > Ampel4.oben)
      then
         Auto4.warte
      else
         begin
            Auto4.bewegeDich;
            // Auto4 ggf an den Anfang
            if Auto4.vPosition < -30 then
               Auto4.setzeAuf (475,derBildschirm.hoehe+30
               );
         end; // von Auto4 bewegt sich

      // Ampel ggf umschalten
      if dieTastatur.wurdegedrueckt and (dieTastatur.zeichen='a') then
         begin
            dieTastatur.weiter;
            Ampel1.schalteUm ;
            Ampel2.schalteUm ;
            Ampel3.schalteUm ;
            Ampel4.schalteUm ;
         end;

until dieTastatur.wurdegedrueckt;


{----- Objekte auflsen -----}
  meinStift.gibFrei;
  dieMaus.gibFrei;
  dieTastatur.gibFrei;
  derBildschirm.gibFrei;
  Auto1.GibFrei;

end.
