UNIT mTAuto;

interface

uses  mSuM,mUhr;

    const laenge = 60.0;
          breite = 30.0;
// Uses-Klausel ggf. anpassen

type
   TAuto = CLASS

     // Attribute
     PRIVATE
        meinStift : Stift;
        meineUhr : Uhr;
        x : zahl;
        y : zahl;
        zWinkel : zahl;

     // Methoden
     PRIVATE
        procedure zeichneDich;
     PUBLIC
        constructor init(px,py:zahl;pWinkel:Zahl);
        procedure bewegeDich;
        procedure dreheBis(pWinkel:zahl);
        procedure dreheUm(pWinkel:zahl);
        procedure setzeAuf(pXpos,pYPos:zahl);
        procedure warte;
        function hPosition : zahl;
        function vPosition : zahl;
        function winkel : zahl;
        destructor GibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAuto: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneDich -------------------------------------------------
procedure TAuto.zeichneDich;
  begin
    with meinStift do
      begin
        hoch;
        bewegeBis(x,y);
        wechsle;
        dreheBis(zWinkel);
        bewegeUm(laenge*0.1);
        dreheBis (zWinkel+90);
        bewegeUm(breite *0.5);
        runter;
        bewegeUm(-breite);
        hoch;
        bewegeUm(breite*0.5);
        //runter;
        dreheBis(zWinkel+180);
        BewegeUm(laenge*0.5);
        BewegeUm(laenge*0.1);
        dreheUm(-90);
        BewegeUm(breite*0.5);
        dreheUm(-90);

        runter;
        dreheBis(zwinkel);
        BewegeUm(laenge*0.8);
        DreheUm(-90);
        BewegeUm(breite*0.2);
        DreheUm(90);
        bewegeUm(laenge*0.2);
        DreheUm(-90);
        bewegeUm(breite*0.6);
        dreheUm(-90);
        bewegeUm(laenge*0.2);
        dreheUm(90);
        bewegeUm(breite*0.2);
        dreheUm(-90);
        bewegeUm(laenge*0.8);
        dreheUm(-90);
        bewegeUm(breite);
        hoch;
        bewegeUm(-breite*0.5);
        dreheBis(zwinkel);
        bewegeUm(laenge*0.5);
        normal
      end;
  end;

//-------- init --------------------------------------------------------
constructor TAuto.init(px,py:zahl;pWinkel:Zahl);
    begin
       meinStift := Stift.init;
       meineUhr := Uhr.init;
       x := px;
       y := py;
       zwinkel := pWinkel;
       zeichneDich;
    end;

//-------- bewegeDich --------------------------------------------------
procedure TAuto.bewegeDich;
  begin
    zeichneDich;
    x := x + 2.0 * cos(zwinkel*pi/180);
    y := y - 2.0 * sin(zwinkel*pi/180);
    zeichneDich;
    meineUhr.warte(1)
  end;

//-------- dreheBis ----------------------------------------------------
procedure TAuto.dreheBis(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- dreheUm -----------------------------------------------------
procedure TAuto.dreheUm(pWinkel:zahl);
  begin
    zeichneDich;
    zwinkel := zwinkel + pWinkel;
    zeichneDich;
    //meineUhr.warte(1)
  end;

//-------- setzeAuf ----------------------------------------------------
procedure TAuto.setzeAuf(pXpos,pYPos:zahl);
   begin
      zeichneDich;
      x := pXpos ;
      y := pYpos ;
      zeichneDich
   end;

//-------- warte -------------------------------------------------------
procedure TAuto.warte;
   begin
      meineUhr.warte(1)
   end;

//-------- hPosition ---------------------------------------------------
function TAuto.hPosition : zahl;
   begin
    result := x;
   end;

//-------- vPosition ---------------------------------------------------
function TAuto.vPosition : zahl;
   begin
    result := y;
   end;

//-------- winkel ------------------------------------------------------
function TAuto.winkel : zahl;
   begin
    result := zWinkel;
   end;

//-------- GibFrei -----------------------------------------------------
destructor TAuto.GibFrei;
    begin
      meinStift.gibfrei;
      meineUhr.gibfrei;
    end;  

end.
